package pps.core.space.service;

import cn.hutool.core.io.FileUtil;
import com.alibaba.excel.EasyExcelFactory;
import com.alibaba.excel.write.style.column.LongestMatchColumnWidthStyleStrategy;
import pps.core.common.excel.util.EasyExcelUtil;
import pps.core.common.excel.util.ExcelStyleTool;
import pps.core.space.service.data.base_excel.ExcelSpaceOptimizeTemplate;
import xstartup.annotation.XService;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.tool.XStorageTool;
import xstartup.data.XFileResult;
import xstartup.data.XFileType;
import xstartup.feature.api.annotation.XApiGet;

import java.util.Collections;

/**
 * excel导入导出
 *
 * @author ZWT
 * @date 2024/05/14 13:44
 */
@XText("Excel导入导出")
@XService
public class ExcelService {

    /**
     * 编辑制度导出
     *
     * @param context 上下文
     * @return {@link XFileResult }
     */
    @XText("编辑制度导出")
    @XApiGet
    public XFileResult exportEditorialSystem(XContext context) {
        String fileSavePath = XStorageTool.getAbsolutePath("/temp/excel/编辑制度模板.xlsx");
        //生成模板
        EasyExcelFactory.write(FileUtil.touch(fileSavePath))
                .registerWriteHandler(ExcelStyleTool.getStyleStrategy())
                .registerWriteHandler(new LongestMatchColumnWidthStyleStrategy())
                .autoCloseStream(Boolean.TRUE)
                .build()
                .write(Collections.emptyList(),
                        EasyExcelUtil.writeSelectedSheet(ExcelSpaceOptimizeTemplate.class, 0, "编辑制度")
                ).finish();
        return XFileResult.success(XFileType.APPLICATION_XLSX, fileSavePath);
    }
}
